<?php

/**
 * Front-end of Expandcontract_XH.
 *
 * PHP versions 4 and 5
 *
 * @category  CMSimple_XH
 * @author    svasti <svasti@svasti.de>
 * @copyright 2014 svasti <http://svasti.de>
 * @version   0.5
 */

/*
 * Prevent direct access.
 */
if (!defined('CMSIMPLE_XH_VERSION')) {
    header('HTTP/1.0 403 Forbidden');
    exit;
}


function expand($link='',$linktext='',$withheading='',$closebutton='',$limitheight='')
{
    global $s, $cl, $l, $cf, $h, $c, $plugin_cf, $plugin_tx, $bjs;

    $o = $t = '';
    $ta = array();

    $withheading = $withheading!==''? $withheading : $plugin_cf['expandcontract']['show_headings'];
    $closebutton = $closebutton!==''? $closebutton : $plugin_cf['expandcontract']['show_close_button'];
    $limitheight = $limitheight!==''? $limitheight : $plugin_cf['expandcontract']['max_height'];

    if($link) {
        for ($i = 0; $i < $cl; $i++) {
            if ($h[$i] == $link) {
                $link = $i;
                break;
            }
        }
        $ta[] = $i;

    } else {
        $tl = $l[$s] + 1 + $cf['menu']['levelcatch'];
        for ($i = $s + 1; $i < $cl; $i++) {
            if ($l[$i] <= $l[$s]) {
                break;
            }
            if ($l[$i] <= $tl) {
                if (hide($i)) {
                    $ta[] = $i;
                }
            }
            if ($l[$i] < $tl) {
                $tl = $l[$i];
            }
        }
    }


    if(!$link) $o .= "\n\n\n<!-- E X P A N D - C O N T R A C T    S T A R T -->\n\n" . '<div class="expand_area">' . "\n";
    foreach ($ta as $key=>$value) {

        $js = '" onclick="expandcontract(\'popup'.$value.$withheading.'\'); return false;';
            // the added $withheading enables multiple calls with different settings on one page for demo purposes

        $content = str_replace('#CMSimple hide#', '', $c[$value]);
        if(!$withheading) {
            $content = preg_replace("/.*<\/h[1-".$cf['menu']['levels']."]>/isU", "", $content);
        }

        if(!$link) $t .= '<p class="expand_link">';
        $t .=  a($value,$js);
        $t .=  $linktext? $linktext : $h[$value];
        $t .=  '</a>';
        if(!$link) $t .= '</p>' . "\n\n";
        $t .= '<div style="display:none;" id="popup'.$value.$withheading.'" class="expand_content">';
        if($limitheight) $t .= '<div style="height:'.$limitheight.';overflow-y:scroll;">';
        $t .= $content . '<div style="clear:both"></div>';
        if($limitheight) $t .= '</div>';
        if($closebutton) {
            $t .= '<button type="submit" onclick="toggle(\'popup'.$value.$withheading.'\');">'
               .  $plugin_tx['expandcontract']['close'] .'</button>';
        }
        $t .= '</div>';
    }
    $o .= evaluate_scripting($t);
    if(!$link) $o .= '</div>' . "\n\n<!-- E X P A N D - C O N T R A C T    E N D -->\n\n\n";

    static $firstExpand = true;
    if ($firstExpand) {
        $firstExpand = false;

        $bjs .= '<script type="text/javascript">
              // <![CDATA[
              function expandcontract(page)
              {
                  if(document.getElementById(page).style.display == \'block\') {
                      document.getElementById(page).style.display = \'none\';
                   } else {
                      document.getElementById(page).style.display = \'block\';
                  }
              }
              // ]]>
              </script>';
    }

    return $o;
}
?>
